您的位置:首页 > 编程语言 > Go语言

Codeforces 616D Longest k-Good Segment(双指针)

2016-01-17 21:56 585 查看
The array a with n integers
is given. Let's call the sequence of one or more consecutive elements in a segment.
Also let's call the segment k-good if it contains no more than k different
values.

Find any longest k-good segment.

As the input/output can reach huge size it is recommended to use fast input/output methods: for example, prefer to use scanf/printfinstead of cin/cout in
C++, prefer to use BufferedReader/PrintWriter instead of Scanner/System.out in Java.

Input

The first line contains two integers n, k (1 ≤ k ≤ n ≤ 5·105)
— the number of elements in a and the parameter k.

The second line contains n integers ai (0 ≤ ai ≤ 106)
— the elements of the array a.

Output

Print two integers l, r (1 ≤ l ≤ r ≤ n)
— the index of the left and the index of the right ends of some k-good longest segment. If there are several longest segments you can print any of them. The elements in a are
numbered from 1 to n from
left to right.

Sample test(s)

input
5 5
1 2 3 4 5


output
1 5


input
9 3
6 5 1 2 3 2 1 4 5


output
3 7


input
3 1
1 2 3


output
1 1


solution:
用双指针简单标记一下,O(n)的复杂度
#include<cstdio>
using namespace std;
const int maxn = 1e6+200;
int f[maxn], a[maxn];
int n, k,l=1,r=1,c,ll=1;
int main()
{
scanf("%d%d", &n, &k);
for (int i = 1; i <=n; i++)
{
scanf("%d", &a[i]);
c += f[a[i]] == 0;
f[a[i]]++;
while (c > k)
{
f[a[ll]]--;
c -= f[a[ll++]] == 0;
}
if (i - ll > r - l)
{
r = i; l = ll;
}
}
printf("%d %d\n", l, r);
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: